package utils

import "reflect"

type seqEntry struct {
	fn     interface{} // Function
	fnVal  reflect.Value
	params []interface{}

	res []reflect.Value
}

type Seq struct {
	seq []seqEntry
}

func NewSeq() *Seq {
	return &Seq{[]seqEntry{}}
}

func (s *Seq) Add(fn interface{}, params ...interface{}) {
	fnTyp := reflect.TypeOf(fn)
	fnVal := reflect.ValueOf(fn)
	if fnTyp.Kind() != reflect.Func {
		log.Fatal("First paran should be a func")
	}
	if fnTyp.NumIn() != len(params) {
		log.Fatal("Param len mismatch required")
	}

	if reflect.TypeOf(fn).Kind() != reflect.Func {
		panic("First param should be a function")

	}
	s.seq = append(s.seq, seqEntry{fn: fn, fnVal: fnVal, params: params, res: []reflect.Value{}})
}

func (s *Seq) Exec() error {
	for _, v := range s.seq {
		vVal := reflect.ValueOf(v)
		vparam := []reflect.Value{}
		for _, p := range v.params {
			vparam = append(vparam, reflect.ValueOf(p))
		}
		v.res = vVal.Call(vparam)

		for _, r := range v.res {
			err, ok := r.Interface().(error)
			if ok {
				log.Println("Error in a func:", err)
				// We got error
				return err
			}
		}
	}

	return nil
}
